> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.coperniq.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.coperniq.io/_mcp/server.

# Get Bill

GET https://api.coperniq.io/v1/bills/{bill_id}

Retrieve a specific bill by ID

Reference: https://docs.coperniq.io/api-reference/bills/get-bill

## Authentication

- `x-api-key` header (required) — API Key authentication via header

## Request

### Path parameters

- `bill_id` (integer, required) — Bill identifier

## Response

### 200

Bill details

- `id` (integer, required) — Bill identifier
- `billNumber` (integer, required) — Unique bill number
- `status` (enum, required) — Bill status
  - Allowed values: `DRAFT`, `SENT`, `DECLINED`, `PAID`, `PARTIALLY_PAID`, `OVERDUE`
- `amount` (double, required) — Total bill amount
- `amountPaid` (double, required) — Amount paid
- `calculationMethod` (string, required) — Calculation method (LINE_ITEMS or PERCENTAGE)
- `createdAt` (string, required) — Creation timestamp
- `updatedAt` (string, required) — Last update timestamp
- `description` (string, optional, nullable) — Bill description
- `basedOnId` (integer, optional, nullable) — ID of the record this bill is based on
- `basedOnUid` (integer, optional, nullable) — UID of the record this bill is based on
- `dueDate` (string, optional) — Due date
- `issueDate` (string, optional, nullable) — Issue date
- `isArchived` (boolean, optional) — Whether the bill is archived
- `percentage` (double, optional, nullable) — Percentage if calculationMethod is PERCENTAGE
- `baseAmount` (double, optional, nullable) — Base amount if calculationMethod is PERCENTAGE
- `account` (BillAccount, optional, nullable)
- `record` (BillRecord, optional, nullable)
- `lineItems` (list of BillLineItem, optional)

## Errors

### 401 Unauthorized Error

Authentication failed

- `message` (string, optional)
- `code` (enum, optional)
  - Allowed values: `NOT_FOUND`

### 404 Not Found Error

Resource not found

- `message` (string, optional)
- `code` (enum, optional)
  - Allowed values: `NOT_FOUND`

## Types

### BillAccount

- `id` (integer, optional)
- `title` (string, optional)

### BillRecord

- `id` (integer, optional)
- `uid` (integer, optional)
- `title` (string, optional)

### BillLineItem

- `id` (integer, required) — Line item identifier
- `catalogItemId` (integer, required) — Catalog item identifier
- `quantity` (integer, required) — Quantity
- `unitCost` (double, required) — Cost per unit (must be greater than 0 for bills)
- `unitPrice` (double, required) — Price per unit (may be negative for discounts)
- `description` (string, optional, nullable) — Line item description
- `catalogItem` (BillLineItemCatalogItem, optional, nullable)

### BillLineItemCatalogItem

- `id` (integer, optional)
- `name` (string, optional)
- `manufacturer` (string, optional, nullable)
- `sku` (string, optional, nullable)
- `type` (enum, optional)
  - Allowed values: `PRODUCT`, `SERVICE`

## Examples

**Response**

```json
{
  "id": 1,
  "billNumber": 1,
  "status": "DRAFT",
  "amount": 1.1,
  "amountPaid": 1.1,
  "calculationMethod": "string",
  "createdAt": "2024-01-15T09:30:00Z",
  "updatedAt": "2024-01-15T09:30:00Z",
  "description": "string",
  "basedOnId": 1,
  "basedOnUid": 1,
  "dueDate": "2024-01-15T09:30:00Z",
  "issueDate": "2024-01-15T09:30:00Z",
  "isArchived": true,
  "percentage": 1.1,
  "baseAmount": 1.1,
  "account": {
    "id": 1,
    "title": "string"
  },
  "record": {
    "id": 1,
    "uid": 1,
    "title": "string"
  },
  "lineItems": [
    {
      "id": 1,
      "catalogItemId": 1,
      "quantity": 1,
      "unitCost": 1.1,
      "unitPrice": 1.1,
      "description": "string",
      "catalogItem": {
        "id": 1,
        "name": "string",
        "manufacturer": "string",
        "sku": "string",
        "type": "PRODUCT"
      }
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.coperniq.io/v1/bills/1"

headers = {"x-api-key": "<apiKey>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.coperniq.io/v1/bills/1';
const options = {method: 'GET', headers: {'x-api-key': '<apiKey>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.coperniq.io/v1/bills/1"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("x-api-key", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.coperniq.io/v1/bills/1")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["x-api-key"] = '<apiKey>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.coperniq.io/v1/bills/1")
  .header("x-api-key", "<apiKey>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.coperniq.io/v1/bills/1', [
  'headers' => [
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.coperniq.io/v1/bills/1");
var request = new RestRequest(Method.GET);
request.AddHeader("x-api-key", "<apiKey>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["x-api-key": "<apiKey>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.coperniq.io/v1/bills/1")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```